## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_without  check

%global forgeurl https://github.com/hugsy/gef

Name:           gdb-gef
Version:        2025.01

%global tag %{version}
%forgemeta

Release:        %autorelease
Summary:        GEF (GDB Enhanced Features)

License:        MIT
URL:            %{forgeurl}
Source0:        %{forgesource}
Source1:        gdb-gef
# https://github.com/hugsy/gef/pull/1094
Patch0:         gef-got-audit.patch
Patch1:         gef-gcc15.patch

BuildArch:      noarch
ExclusiveArch:  x86_64

Requires:       gdb
Requires:       file
Requires:       binutils
Requires:       procps-ng

%if %{with check}
# These are required for tests:
BuildRequires:  gdb
BuildRequires:  gdb-gdbserver
BuildRequires:  file
BuildRequires:  binutils
BuildRequires:  procps-ng
BuildRequires:  python3
BuildRequires:  python3-pylint
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-benchmark
BuildRequires:  python3-pytest-cov
BuildRequires:  python3-pytest-xdist
BuildRequires:  python3-coverage
BuildRequires:  python3-rpyc
BuildRequires:  python3-requests
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  qemu-user
BuildRequires:  git
%endif
BuildRequires:  sed


%description
GEF (pronounced ʤɛf - "Jeff") is a set of commands for x86/64, ARM,
MIPS, PowerPC and SPARC to assist exploit developers and
reverse-engineers when using old school GDB. It provides additional
features to GDB using the Python API to assist during the process of
dynamic analysis and exploit development. Application developers will
also benefit from it, as GEF lifts a great part of regular GDB
obscurity, avoiding repeating traditional commands, or bringing out
the relevant information from the debugging runtime.


%prep
%forgesetup
%patch 0 -p1
%patch 1 -p1


%build


%install
mkdir -p %{buildroot}/%{_datadir}/gdb
cp gef.py %{buildroot}/%{_datadir}/gdb/gef.py

sed -e "s:@datadir@:%{_datadir}:g" < %{SOURCE1} > %{SOURCE1}.sh
mkdir -p %{buildroot}/%{_bindir}
install -m 0755 %{SOURCE1}.sh %{buildroot}/%{_bindir}/gdb-gef


%if %{with check}
%check
make -C tests/binaries
python3 -m pytest -v -m "not benchmark" -m "not online" tests/
%endif


%files
%license LICENSE
%doc docs/* README.md
%{_datadir}/gdb/gef.py
%{_bindir}/gdb-gef


%changelog
## START: Generated by rpmautospec
* Wed Feb 12 2025 Gordon Messmer <gordon.messmer@gmail.com> - 2025.01-1
- Update to 2025.01

* Tue Feb 11 2025 Gordon Messmer <gordon.messmer@gmail.com> - 2024.06-9
- Update function prototype to fix gcc 15 build failure.

* Thu Jan 16 2025 Fedora Release Engineering <releng@fedoraproject.org> - 2024.06-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Aug 06 2024 Gordon Messmer <gordon.messmer@gmail.com> - 2024.06-7
- Update got-audit with symbol collection from the executable.

* Sat Aug 03 2024 Gordon Messmer <gordon.messmer@gmail.com> - 2024.06-6
- Update got-audit with expected duplicate symbols from libresolv and
  libvncserver and ignore unresolved symbols.

* Thu Aug 01 2024 Gordon Messmer <gordon.messmer@gmail.com> - 2024.06-5
- Update got-audit with expected duplicate symbols from libattr

* Sun Jul 28 2024 Gordon Messmer <gordon.messmer@gmail.com> - 2024.06-4
- Update got-audit with expected duplicate symbols from libsasl2

* Sun Jul 28 2024 Gordon Messmer <gordon.messmer@gmail.com> - 2024.06-3
- Update got-audit with expected duplicate symbols from libm and libtirpc

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2024.06-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sun Jun 23 2024 Gordon Messmer <gordon.messmer@gmail.com> - 2024.06-1
- Build 2024.06
## END: Generated by rpmautospec
